SystemOrganization addCategory: #ProyectoFinal!

Object subclass: #Emisor
	instanceVariableNames: 'nombre apellido DNI CUIT direccion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

Object subclass: #Orden
	instanceVariableNames: 'cantidad precioTotal precioUnitario fecha emisor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!Orden class methodsFor: 'class initialization' stamp: 'PauloPerez 7/9/2012 12:32'!
conEmisor: anEmisor conCantidad: aCantidad conPrecioTotal: aPrecioTotal conFecha: aDate
	^ (self new)
		conEmisor: anEmisor
			conCantidad: aCantidad
			conPrecioTotal: aPrecioTotal
			conFecha: aDate;
		yourself! !

!Orden methodsFor: 'private' stamp: 'DiegoValdeblanquez 7/4/2012 23:26'!
calcularPrecioUnitario
	precioUnitario := precioTotal / cantidad! !

!Orden methodsFor: 'accessing' stamp: 'PauloPerez 7/9/2012 12:32'!
conEmisor: anEmisor conCantidad: aCantidad conPrecioTotal: aPrecioTotal conFecha: aDate
	emisor := anEmisor.
	cantidad := aCantidad.
	precioTotal := aPrecioTotal.
	fecha := aDate.
	self calcularPrecioUnitario! !

Orden subclass: #OrdenCompra
	instanceVariableNames: 'direccionRecepcion formaEnvio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

Orden subclass: #OrdenVenta
	instanceVariableNames: 'medioPago fechaDisponibilidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

Object subclass: #OrderBook
	instanceVariableNames: 'ordenesCompra ordenesVenta precioMercado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!OrderBook methodsFor: 'accessing' stamp: 'PauloPerez 7/9/2012 21:44'!
addOrden: anOrden
	"Agrega una orden al arreglo de ordenes dependiendo de su tipo"

	(anOrden isMemberOf: OrdenCompra)
		ifTrue: [ ordenesCompra add: anOrden ].
	(anOrden isMemberOf: OrdenVenta)
		ifTrue: [ ordenesVenta add: anOrden ]! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/4/2012 23:34'!
calcularPrecioMercado
	"comment stating purpose of message"

	| temporary variable names |
	^ precioMercado! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/10/2012 11:58'!
comercializar
	"comment stating purpose of message"

	| tradingTickets ordenVenta ordenCompra |
	tradingTickets := OrderedCollection new.
	tradingTickets
		conOrdenCompra: ordenCompra
		conOrdenVenta: ordenVenta
		conPrecioMercado: precioMercado
		conFechaTransaccion: Date today.
	^ tradingTickets! !

!OrderBook methodsFor: 'initialize-release' stamp: 'PauloPerez 7/9/2012 22:00'!
initialize
	ordenesCompra := OrderedCollection new.
	ordenesVenta := OrderedCollection new! !

Object subclass: #PEM
	instanceVariableNames: 'tradingTickets emisores orderBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!PEM methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/5/2012 00:08'!
addEmisor: anEmisor
	"Agrega un empleado al arreglo de empleados"

	anEmisor isNil
		ifFalse: [ emisores add: anEmisor ]! !

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/9/2012 21:21'!
calcularPrecioMercado
	^ orderBook calcularPrecioMercado! !

!PEM methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/10/2012 17:37'!
comercializar
	"comment stating purpose of message"

	^ orderBook comercializar! !

!PEM methodsFor: 'initialize-release' stamp: 'PauloPerez 7/9/2012 21:20'!
initialize
	tradingTickets := OrderedCollection new.
	emisores := OrderedCollection new.
	orderBook := OrderBook new! !

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/9/2012 21:29'!
recibirOrden: anOrden
	"Agrega una orden al orderBook"

	anOrden isNil
		ifFalse: [ orderBook addOrden: anOrden ]! !

Object subclass: #TradingTicket
	instanceVariableNames: 'precioMercado fechaTransaccion ordenCompra ordenVenta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!TradingTicket methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/10/2012 11:56'!
conOrdenCompra: anOrdenCompra conOrdenVenta: anOrdenVenta conPrecioMercado: aPrecioMercado conFechaTransaccion: aFechaTransaccion
	"Mensaje que escribe en cada TradingTicket los datos de las ordenes de compra y venta que se puedieron efectivizar a un cierto precio de mercado calculado y definido en una fecha determinada."

	ordenCompra := anOrdenCompra.
	ordenVenta := anOrdenVenta.
	precioMercado := aPrecioMercado.
	fechaTransaccion := aFechaTransaccion! !

!TradingTicket methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/10/2012 17:04'!
printOn: aStream
	aStream
		nextPutAll: 'Orden de compra ';
		print: ordenCompra;
		space;
		space;
		nextPutAll: 'Orden de venta ';
		print: ordenVenta;
		space;
		space;
		nextPutAll: 'Precio mercado ';
		print: precioMercado;
		cr;
		nextPutAll: 'Fecha transaccin ';
		print: fechaTransaccion;
		cr.
	aStream cr! !
